#ifndef __COMMON_PATCHERS__
#define __COMMON_PATCHERS__

struct Target
{
    int iSize;
    unsigned char * pData;
    unsigned char * pFlags;
    int iSizeOfRels;
    unsigned char * pRels;
};

typedef struct _Core_Allocator
{
    void * (__stdcall *pAllocateBuffer)(void * pAllocator, int iSize);
    void (__stdcall  *pFreeBuffer)(void * pAllocator, void * pBuffer);
}Core_Allocator;

// 1. Standard header
// 805b3543 8bff             mov     edi,edi
// 805b3545 55               push    ebp
// 805b3546 8bec             mov     ebp,esp
static unsigned char g_STD_Val[] = {0x8b,0xff,0x55,0x8b,0xec};
static unsigned char g_STD_Mask[] = {0xFF,0xFF,0xFF,0xFF,0xFF};
static struct Target g_STD_Target = {sizeof(g_STD_Val),g_STD_Val,g_STD_Mask,0,0};



// 2. The beginning of SEH frame
// 8056c608 681c010000       push    0x11c
static unsigned char g_PushConstTarget_Val[] = {0x68,0,0,0,0};
static unsigned char g_PushConstTarget_Mask[] = {0xFF,0,0,0,0};
static struct Target g_PushConstTarget = {sizeof(g_PushConstTarget_Val), 
g_PushConstTarget_Val, 
g_PushConstTarget_Mask,
0,
0};


// 3. STD hooked
// 805b3543 EBF6             jmp $-5
// 805b3545 55               push    ebp
// 805b3546 8bec             mov     ebp,esp

static unsigned char g_HookedSTD_Val[] = {0xEB,0,0x55,0x8B,0xEC};
static unsigned char g_HookedSTD_Mask[] = {0xFF,0,0xFF,0xFF,0xFF};
static struct Target g_HookedSTD = {sizeof(g_HookedSTD_Val), 
g_HookedSTD_Val, 
g_HookedSTD_Mask,
0,
0};

// 4. STD2
// 8052de85 55               push    ebp
// 8052de86 8bec             mov     ebp,esp
// 8052de88 51               push    ecx
// 8052de89 53               push    ebx

static unsigned char g_STD2_Val[] = {0x55, 0x8b, 0xec, 0x50, 0x50};
static unsigned char g_STD2_Mask[] = {0xFF, 0xFF, 0xFF, 0xF0, 0xF0};
static struct Target g_STD2 = {sizeof(g_STD2_Val), 
g_STD2_Val, 
g_STD2_Mask,
0,
0};


// 5. STD3
// fa50f8e1 55               push    ebp
// fa50f8e2 8bec             mov     ebp,esp
// fa50f8e4 83ec20           sub     esp,0x20

static unsigned char g_STD3_Val[] = {0x55, 0x8b, 0xec, 0x83, 0xec, 0x00};
static unsigned char g_STD3_Mask[] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00};
static struct Target g_STD3 = {sizeof(g_STD3_Val), 
g_STD3_Val, 
g_STD3_Mask,
0,
0};

// 6. STD4
// 0041B170 55                 push        ebp  
// 0041B171 8B EC              mov         ebp,esp 
// 0041B173 81 EC C0 00 00 00  sub         esp,0C0h 

static unsigned char g_STD4_Val[] = {0x55, 0x8b, 0xec, 0x81, 0xec, 0x00, 0x00, 0x00, 0x00};
static unsigned char g_STD4_Mask[] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00};
static struct Target g_STD4 = {sizeof(g_STD4_Val), 
g_STD4_Val, 
g_STD4_Mask,
0,
0};



// 7. STD5
//804a76ca 55               push    ebp
//804a76cb 8bec             mov     ebp,esp
//804a76cd 6aff             push    0xff
//804a76cf 68e0354080       push    0x804035e0

//or
//A009AE39     55          		  push    ebp
//A009AE3A     8BEC		          mov     ebp, esp
//A009AE3C     6AFF       	      push    0FFFFFFFFh
//A009AE3E     68288817A0         push    offset unk_A0178828

static unsigned char g_STD5_Val[] = {0x55, 0x8b, 0xec, 0x6A, 0x00};
static unsigned char g_STD5_Mask[] = {0xFF, 0xFF, 0xFF, 0xFF, 0x00};
static struct Target g_STD5 = {sizeof(g_STD5_Val), 
g_STD5_Val, 
g_STD5_Mask,
0,
0};



// 8. STD6
//804a76ca 55               push    ebp
//804a76cb 8bec             mov     ebp,esp
//804a76cf 68e0354080       push    0x804035e0
//804a76cd 6aff             push    0xff

static unsigned char g_STD6_Val[] = {0x55, 0x8b, 0xec, 0x68, 0x00, 0x00, 0x00, 0x00};
static unsigned char g_STD6_Mask[] = {0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00};
static struct Target g_STD6 = {sizeof(g_STD6_Val), 
g_STD6_Val, 
g_STD6_Mask,
0,
0};

//9. STD7
//bf8cd389 6a18            push    18h
//bf8cd38b 6808af98bf      push    offset win32k!`string'+0x168 (bf98af08)

static unsigned char g_STD7_Val[] = {0x6a, 0x18, 0x68, 0x00, 0x00, 0x00, 0x00};
static unsigned char g_STD7_Mask[] = {0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00};
static struct Target g_STD7 = {sizeof(g_STD7_Val), 
g_STD7_Val, 
g_STD7_Mask,
0,
0};


//9. STD8
//bf908d92 6a20            push    20h
//bf908d94 6808b098bf      push    offset win32k!`string'+0x268 (bf98b008)

static unsigned char g_STD8_Val[] = {0x6a, 0x20, 0x68, 0x00, 0x00, 0x00, 0x00};
static unsigned char g_STD8_Mask[] = {0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00};
static struct Target g_STD8 = {sizeof(g_STD8_Val), 
g_STD8_Val, 
g_STD8_Mask,
0,
0};

// 10. STD9
//a009af42 55              push    ebp
//a009af43 8bec            mov     ebp,esp
//a009af45 56              push    esi
//a009af46 57              push    edi

static unsigned char g_STD9_Val[] = {0x55, 0x8b, 0xec, 0x56, 0x57};
static unsigned char g_STD9_Mask[] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF};
static struct Target g_STD9 = {sizeof(g_STD9_Val), 
g_STD9_Val, 
g_STD9_Mask,
0,
0};

// 11. STD10
//bf8cd3f6 55              push    ebp
//bf8cd3f7 8bec            mov     ebp,esp
//bf8cd3f9 e85daff5ff      call    bf82835b
//bf8cd3fe 85c0            test    eax,eax
static unsigned char g_STD10_Val[] = {0x55, 0x8b, 0xec, 0xe8, 0x00, 0x00, 0x00, 0x00};
static unsigned char g_STD10_Mask[] = {0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00};
static unsigned char g_STD10_Rels[] = {0x4};
static struct Target g_STD10 = {sizeof(g_STD10_Val), 
g_STD10_Val, 
g_STD10_Mask,
sizeof(g_STD10_Rels),
g_STD10_Rels};

// 12. STD11
//nt!MmMapViewOfSection:
//80583b7f 6a34            push    34h
//80583b81 6888325080      push    offset nt!MMDB+0x50 (80503288)

static unsigned char g_STD11_Val[] = {0x6a, 0x34, 0x68, 0x00, 0x00, 0x00, 0x00};
static unsigned char g_STD11_Mask[] = {0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00};
static struct Target g_STD11 = {sizeof(g_STD11_Val), 
g_STD11_Val, 
g_STD11_Mask,
0,
0};

// 13. STD12
//user32!GetClipboardOwner:
//77d60d80 b887110000      mov     eax,1187h

static unsigned char g_STD12_Val[] = {0xb8, 0x00, 0x00, 0x00, 0x00};
static unsigned char g_STD12_Mask[] = {0xF8, 0x00, 0x00, 0x00, 0x00};
static struct Target g_STD12 = {sizeof(g_STD12_Val), 
g_STD12_Val, 
g_STD12_Mask,
0,
0};

// 14. STD13
//77d5fc2a 6a00            push    0
//77d5fc2c e8eea1feff      call    77d49e1f

static unsigned char g_STD13_Val[]  = {0x6a, 0x00, 0xe8, 0x00, 0x00, 0x00, 0x00};
static unsigned char g_STD13_Mask[] = {0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00};
static unsigned char g_STD13_Rels[] = {0x03};
static struct Target g_STD13 = {sizeof(g_STD13_Val), 
g_STD13_Val, 
g_STD13_Mask,
sizeof(g_STD13_Rels),
g_STD13_Rels};


// 15. STD14
//77d5fc2a ff25d01a4780    jmp 80471ad0
static unsigned char g_STD14_Val[] = {0xFF, 0x25, 0x00, 0x00, 0x00, 0x00};
static unsigned char g_STD14_Mask[]= {0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00};
static struct Target g_STD14 = {sizeof(g_STD14_Val), 
g_STD14_Val, 
g_STD14_Mask,
0,
0};

// 16. STD15
//77180c94 6a14            push    14h
//77180c96 68680d1877      push    77180D68h

static unsigned char g_STD15_Val[] = {0x6a, 0x14, 0x68, 0x00, 0x00, 0x00, 0x00};
static unsigned char g_STD15_Mask[] = {0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00};
static struct Target g_STD15 = {sizeof(g_STD15_Val), 
g_STD15_Val, 
g_STD15_Mask,
0,
0};

// 17. STD16
//7717dc5c 6a0c            push    0Ch
//7717dc5e 68e0dc1777      push    7717DCE0h

static unsigned char g_STD16_Val[] = {0x6a, 0x0C, 0x68, 0x00, 0x00, 0x00, 0x00};
static unsigned char g_STD16_Mask[] = {0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00};
static struct Target g_STD16 = {sizeof(g_STD16_Val), 
g_STD16_Val, 
g_STD16_Mask,
0,
0};

#endif