#pragma once

#include "HookMng.h"
#include "IProcessChecker.h"
#include "PLUtils.h"

namespace HideDriver
{

#define DEFINE_POST_HANDLER(Name, ImplName,ParamsData)          \
    static void __stdcall ImplName(unsigned long * pRetValue,   \
    ParamsData * pData,                                         \
    unsigned long dwOldEax);                                    \
    static __declspec(naked) void __stdcall Name()              \
    {                                                               \
    __asm pushad                                                \
    __asm push eax                                              \
    __asm mov eax, [esp+0x28]                                   \
    __asm push eax                                              \
    __asm lea eax, [esp+0x28]                                   \
    __asm push eax                                              \
    __asm call ImplName                                         \
    __asm popad                                                 \
    __asm ret 4                                                 \
}                             
    //-------------------------------------------------------------------------   
#define DEFINE_FORE_HANDLER(Name, ImplName)                     \
    static void __stdcall ImplName(unsigned long * pFirstData); \
    static __declspec(naked) void __stdcall Name()              \
    {                                                               \
    __asm pushad                                                \
    __asm lea eax, [esp+0x28]                                   \
    __asm push eax                                              \
    __asm call ImplName                                         \
    __asm popad                                                 \
    __asm ret                                                   \
}
    //-------------------------------------------------------------------------

#define GET_RET_POINT_PTR(pFirstData) \
    (pFirstData-1)

class ProcessHook
{
    SSTHook hook_;

public:
	ProcessHook(HideAlgorithm::IProcessChecker* processChecker);

    void Initialize(HookMng& refHookMng);
    void Cleanup(HookMng& refHookMng);
    void CreateSpliceHook(PUNICODE_STRING function_name);
};

}//namespace HideDriver